precision mediump float;

varying vec2 vTextureCoord;

uniform vec2 uTextureSize;

uniform sampler2D uSampler;

uniform int uOverrideColor;
uniform vec4 uOverridingColor;

uniform vec2 uSecondOffset;

uniform bool uPrimaryEnabled;
uniform bool uSecondEnabled;
uniform bool uGridOn;
uniform bool uNegative;

void main(void) {
	vec4 primaryColor = texture2D(uSampler, vTextureCoord);
	vec4 secondaryColor = texture2D(uSampler, vTextureCoord + (vec2(uSecondOffset.x, -uSecondOffset.y) / uTextureSize));
	
	float epsilon = 0.1;
	
	if(uGridOn && (mod(vTextureCoord.x * uTextureSize.x, 1.0) < epsilon || mod(vTextureCoord.y * uTextureSize.y, 1.0) < epsilon)) {
		gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
	} else if(secondaryColor.a == 1.0 && uSecondEnabled) {
		if(secondaryColor.a < 0.5) {
			discard;
		} else {
			gl_FragColor = secondaryColor;
		}
	
	} else if(uPrimaryEnabled) {
		if(primaryColor.a < 0.5) {
			discard;
		} else {
			gl_FragColor = primaryColor;
		}
	} else {
		discard;
	}
}